/************************************************************************//**
* \file main.c
* \brief LAB EXERCISE 5.2 - SQUARE ROOT APPROXIMATION
*
* Write an assembly code subroutine to approximate the square root of an 
* argument using the bisection method. All math is done with integers, so the 
* resulting square root will also be an integer
******************************************************************************
* GOOD LUCK!
 ****************************************************************************/

 #include "stdint.h"
 #include <stdio.h>
 
 
 /** @cond DO_NOT_INCLUDE_WITH_DOXYGEN */
 #include "string.h"
 /** @endcond */
 
 /**
 * @brief 5863 Write a brief description of the function here
 *
 * Detailed description of the function after one line gap
 *
 * @note You can also add a note this way
 *
 * @param[in] 
 *  You can also start writing on a new line. 
 *  And continue on the next line. This is how you describe an input parameter
 *
 * @return
 *  This is how you describe the return value
 * 
 */
__asm int my_sqrt(int x){
    PUSH {r4-r7} ; we use r4-r7, which are callee stored registers, so we need to save them on the stack
    
  MOVS r1, #0; r1 will be the register to store a, initialized to 0
  MOVS r2,#200; r2 is for variable b, store the largest squaure root round[sqrt(2^31-1)] (46341)
  MOVS r3,#1;  r3 is for variable c, it has been define and intialized
  NEGS r3,r3;
  MOVS r4,#0; r4 is for variable done
    
loop_while  
    
  MOVS r5,r3; r5 is allocated for c old within the code
  ADDS r3, r1, r2; stores into c = a+b
  LSRS r3,r3,#1; multiply c by 0.5 to get c= (a+b)/2, completed a shift to complete division
  MOVS r6,r3; r6 is allocated for c within the code
  MULS r6,r6,r6; r6 now contains x*x as implemented int code
    
  CMP   r6,r0;   Compare c*c and x, start of the if loop
  BEQ sqrt_loop_done
  BLT sqrt_elseif
    
  MOVS r2,r3; b is loaded with the value of c, b <--c
    
  B end_of_sqrtloop
sqrt_elseif
    MOVS r1,r3; a is loaded with the value of c, a <--c
  B end_of_sqrtloop
    
sqrt_loop_done
    
  MOVS r4,#1; store 1 into the variable done
    
end_of_sqrtloop
  MVNS r6,r4;     r6 ==!done, was c*c above
  CMP r5, r3;     compare cold and c
  BNE skip
  MOVS r7,#0;      set r7 equal to 0 if cold and c are equal
  B skip_over
skip
  MOVS r7,#1;
  NEGS r7,r7;
skip_over
  CMP r6,r7;
  BEQ loop_while
        
    MOVS r0,r3 ; store the return value in r0
    POP {r4-r7} ; restore r4-r7
  BLX  lr            ; Else return from subroutine with link and returning the variable c
    //CMP 
    

}

/*----------------------------------------------------------------------------
 MAIN function
 *----------------------------------------------------------------------------*/
 /**
 * @brief Main function
 *
 * Detailed description of the main
 */
 /*
int main(void){
    int test_values[4] = {2,4,22,121};
    volatile int result = 0;
  
    for (int i = 0; i < 4; i++)
    {
        result = my_sqrt(test_values[i]);
        printf("my_sqrt(%d): %d\n\r", test_values[i], result);
    }
}
*/

// *******************************ARM University Program Copyright © ARM Ltd 2014*************************************/
